﻿
using System;
using System.Collections.Generic;
using System.Linq;
using Wisej.Web;

namespace Wisej.UserComboBoxDGVLookup
{
	public partial class Page2 : Page
	{
		BindingSource bsEmployee, bsEmployments;

		public Page2()
		{
			InitializeComponent();

			drEmployments.CurrentItemIndexChanged += DrEmployments_CurrentItemIndexChanged;

			bsEmployee = new BindingSource();
			bsEmployee.DataSource = typeof(Employee);

			bsEmployments = new BindingSource();
			bsEmployments.DataSource = typeof(List<Employment>);

			Person person = new Person { FirstName = "Alex", LastName = "Prinias" };
			Company company1 = new Company { Name = "Wisej" };
			Company company2 = new Company { Name = "Icetea" };

			Employee employee = new Employee { Person = person };
			var employments = new List<Employment>();
			employments.Add(new Employment { Company = company1, Employee = employee }) ;
			employments.Add(new Employment { Company = company2, Employee = employee });

			txtFirst.DataBindings.Add(new Binding("Text", bsEmployee, "Person.FirstName"));
			txtLast.DataBindings.Add(new Binding("Text", bsEmployee, "Person.LastName"));
			txtFullFlat.DataBindings.Add(new Binding("Text", bsEmployee, "FullName"));


			var b = new Binding("Text", bsEmployments, "Company.Name");


			txtCompanyFlat.DataBindings.Add(new Binding("Text", bsEmployments, "CompanyName"));
			txtEmployeeFlat.DataBindings.Add(new Binding("Text", bsEmployments, "EmployeeLastName"));
			txtCompanyNest.DataBindings.Add(new Binding("Text", bsEmployments, "Company.Name"));
			txtEmployeeNest.DataBindings.Add(new Binding("Text", bsEmployments, "Employee.Person.LastName"));

			bsEmployee.DataSource = employee;
			bsEmployments.DataSource = employments;

			drEmployments.DataSource = bsEmployments;

		}

        private void DrEmployments_CurrentItemIndexChanged(object sender, EventArgs e)
        {


			foreach (TextBox control in drEmployments.ItemTemplate.Controls)
			{
				object data = ((List<Employment>)((BindingSource)drEmployments.DataSource).DataSource)[drEmployments.CurrentItemIndex];
				//Control control = drEmployments.ItemTemplate.Controls[""];

				var binding = control.DataBindings[0];
				var path = binding.BindingMemberInfo.BindingField;
				if (!String.IsNullOrEmpty(binding.BindingMemberInfo.BindingPath))
				{
					path = binding.BindingMemberInfo.BindingPath + "." + path;
					control.DataBindings.Remove(binding);
				}

				string[] properties = path.Split('.');
				for (int i = 0; i < properties.Length && data != null; i++)
					data = data.GetType().GetProperty(properties[i]).GetValue(data);

				control.Text = data.ToString();
			}
		}

		//private void Grid_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
		//{
		//	DataGridViewColumn column = Grid.Columns[e.ColumnIndex];
			

		//	if (control.DataBindings.ToList().Any())


		//	if (column.DataPropertyName.Contains("."))
		//	{
		//		object data = Grid.Rows[e.RowIndex].DataBoundItem;
		//		string[] properties = column.DataPropertyName.Split('.');
		//		for (int i = 0; i < properties.Length && data != null; i++)
		//			data = data.GetType().GetProperty(properties[i]).GetValue(data);
		//		Grid.Rows[e.RowIndex].Cells[e.ColumnIndex].Value = data;
		//	}
		//}
	}

	public class Employee
    {
		public int NumEmployments { get; set; }
        public Person Person { get; set; }
        public string FullName { get => Person.FirstName + " " + Person.LastName; }
        public List<Employment> Employments { get; set; }
    }

	public class Person
    {
		public string FirstName { get; set; }
        public string LastName { get; set; }

    }

	public class Company
    {
		public string Name { get; set; }
    }

	public class Employment
    {
		public string CompanyName { get => Company.Name; }
        public string EmployeeLastName { get => Employee.Person.LastName; }
        public Company Company { get; set; }
        public Employee Employee { get; set; }
    }

}
